#include <stdio.h>
#include <math.h>

/*
-------------------------------------------------------------------------------
Competicio pels mateixos recursos (sense normalitzar)
-------------------------------------------------------------------------------
Dades: dt (mida del pas), imax (passos que es volen calcular), jmax 
       (iteracions per estabilitzar), nx0 (nombre inicial especie x),
       ny0 (nombre inicial especie y), a (influencia d'y sobre x), b
       (influencia de x sobre y), rx (taxa de creixement x), ry (taxa
       de creixement y), Kx (capacitat especie x), Ky (capacitat 
       especie y)
Resultats: Al fitxer "edos2.dat". Cada fila representa un instant de temps.
           La primera columna es el temps, la segona el nombre de membres de 
           l'especie x i la tercera el mateix pero de l'especie y.
Dades de prova: dt=0.05 imax=200 jmax=1 nx0=200 ny0=300 a=0.75 b=0.75
                rx=2.0 ry=2.0 Kx=1000 Ky=1000 ==>
                0.000000 200.000000 300.000000
                0.050000 211.500000 316.500000
                0.100000 223.156296 333.112305
                0.150000 234.916840 349.751953
                0.200000 246.727737 366.332306
                   ...      ...      ...
Observacions: Totes les quantitats es refereixen al model sense normalitzar.
              Nomes jmax=1 esta justificat teoricament.            
-------------------------------------------------------------------------------
*/

main()
{

int i,j,imax,jmax;
float dx,dy,dt,x0,y0,t0,x,y,t,xf,yf,tf,
      xm,ym,tm,Kx,Ky,rx,ry,a,b,nx0,ny0;
FILE *arxiu;

printf("Mida del pas: ");
scanf("%f",&dt);
printf("Passos que vols calcular: ");
scanf("%d",&imax);
printf("Iteracions per estabilitzar: ");
scanf("%d",&jmax);
printf("Nombre inicial especie x: ");
scanf("%f",&nx0);
printf("Nombre inicial especie y: ");
scanf("%f",&ny0);
printf("Influencia especie y sobre x (a): ");
scanf("%f",&a);
printf("Influencia especie x sobre y (b): ");
scanf("%f",&b);
printf("Taxa de creixement especie x: ");
scanf("%f",&rx);
printf("Taxa de creixement especie y: ");
scanf("%f",&ry);
printf("Capacitat especie x: ");
scanf("%f",&Kx);
printf("Capacitat especie y: ");
scanf("%f",&Ky);

arxiu=fopen("edos2.dat","w");
t0=0;
x=nx0;
y=ny0;
t=t0;
xf=nx0;
yf=ny0;
fprintf(arxiu,"%f %f %f\n",t0,nx0,ny0);
for(i=0;i<imax;i++)   
   {
   tm=t+dt/2.0;
   for(j=0;j<jmax;j++)
      {
      xm=(x+xf)/2.0;
      ym=(y+yf)/2.0;
      dx=rx*(Kx-xm-a*ym)*xm*dt/Kx;
      dy=ry*(Ky-ym-b*xm)*ym*dt/Ky;
      xf=x+dx;
      yf=y+dy;
      }
   x=xf;
   y=yf;
   t=t+dt;         
   fprintf(arxiu,"%f %f %f\n",t,x,y);
   }
fclose(arxiu);
}
